blob: 8ddeea0f461c546c6fb0ae4a74d83c7989431ff3 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Paul Menzela46a7122013-02-23 18:37:27 +010020# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Patrick Georgi53c388f2015-03-07 09:55:18 +010023CROSSGCC_DATE="March 8th, 2015"
24CROSSGCC_VERSION="1.27"
Stefan Reinauer074d9132009-09-26 16:43:17 +000025
26# default settings
27TARGETDIR=`pwd`/xgcc
28TARGETARCH=i386-elf
29DESTDIR=
30
31# version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010032GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070033MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010034MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000035LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010036GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070037GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010038BINUTILS_VERSION=2.25
39GDB_VERSION=7.9
40IASL_VERSION=20150204
41PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020042EXPAT_VERSION=2.1.0
Stefan Reinauer074d9132009-09-26 16:43:17 +000043
44# archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010045GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020046MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020047MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000048LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020049GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070050BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010051GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
52IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
53PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010054EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000055
56GMP_DIR="gmp-${GMP_VERSION}"
57MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000058MPC_DIR="mpc-${MPC_VERSION}"
59LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000060GCC_DIR="gcc-${GCC_VERSION}"
61BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
62GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060063IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010064PYTHON_DIR="Python-${PYTHON_VERSION}"
65EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000066
Patrick Georgi6321f522015-02-27 23:36:26 +010067unset MAKELEVEL MAKEFLAGS
68
Stefan Reinauer074d9132009-09-26 16:43:17 +000069SAVETEMPS=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010070SKIPGDB=1
71SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000072
Patrick Georgi1861ff72011-10-31 12:15:55 +010073red='\033[0;31m'
74RED='\033[1;31m'
75green='\033[0;32m'
76GREEN='\033[1;32m'
77blue='\033[0;34m'
78BLUE='\033[1;34m'
79cyan='\033[0;36m'
80CYAN='\033[1;36m'
81NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000082
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070083UNAME=`uname`
84
Patrick Georgi198d23c2012-12-08 08:02:44 +010085normalize_dirs()
86{
87 mkdir -p $DESTDIR$TARGETDIR/lib
88 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
89 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
90 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
91
92 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
93 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
94}
95
Stefan Reinauer074d9132009-09-26 16:43:17 +000096searchgnu()
97{
98 # $1 short name
99 # result: GNU version of that tool on stdout
100 # or no output if no GNU version was found
101 for i in "$1" "g$1" "gnu$1"; do
102 if test -x "`which $i 2>/dev/null`"; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100103 if test `$i --version 2>/dev/null |grep -c GNU` \
104 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000105 echo $i
106 return
107 fi
108 fi
109 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800110 # A workaround for OSX 10.9 and some BSDs, whose nongnu
111 # patch and tar also work.
112 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800113 if [ $1 != "make" ]; then
114 if test -x "`which $1 2>/dev/null`"; then
115 echo $1
116 return
117 fi
118 fi
119 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000120 printf "${RED}ERROR:${red} Missing toolchain: $1${NC}\n" >&2
121 exit 1
122}
123
Patrick Georgi68df8042011-07-17 11:36:10 +0200124TAR=`searchgnu tar` || exit $?
125PATCH=`searchgnu patch` || exit $?
126MAKE=`searchgnu make` || exit $?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000127
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200128searchgnu m4 > /dev/null
129searchgnu bison > /dev/null
Patrick Georgi0a3f2392012-11-20 12:04:32 +0100130
131if ! flex --version > /dev/null 2> /dev/null; then
132 printf "${RED}ERROR:${red} Missing toolchain: flex${NC}\n" >&2
133 exit 1
134fi
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200135
Stefan Reinauer074d9132009-09-26 16:43:17 +0000136cleanup()
137{
138 printf "Cleaning up temporary files... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200139 rm -rf ${BUILDDIRPREFIX}-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-*
Patrick Georgi969cd932012-12-07 13:13:53 +0100140 rm -rf gdb-* acpica-* python-* expat-*
Stefan Reinauer074d9132009-09-26 16:43:17 +0000141 printf "${green}ok${NC}\n"
142}
143
144myhelp()
145{
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100146 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000147 printf " $0 [-V|--version]\n"
148 printf " $0 [-h|--help]\n\n"
149
150 printf "Options:\n"
151 printf " [-V|--version] print version number and exit\n"
152 printf " [-h|--help] print this help and exit\n"
153 printf " [-c|--clean] remove temporary files before build\n"
154 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100155 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000156 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000157 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
158 printf " (defaults to $TARGETARCH)\n"
159 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
160 printf " (defaults to $TARGETDIR)\n\n"
161 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100162 printf " (for RPM builds, default unset)\n"
163 printf " [-G|--gdb] build GNU debugger\n"
164 printf " [-S|--scripting] build scripting support for GDB\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165}
166
167myversion()
168{
169 # version tag is always printed, so just print the license here
170
171 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000172Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600173Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000174
175This program is free software; you can redistribute it and/or modify
176it under the terms of the GNU General Public License as published by
177the Free Software Foundation; version 2 of the License.
178
179This program is distributed in the hope that it will be useful,
180but WITHOUT ANY WARRANTY; without even the implied warranty of
181MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
182GNU General Public License for more details.
183
184EOF
185}
186
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700187printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000188
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000189# Look if we have getopt. If not, build it.
190export PATH=$PATH:.
191getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
192
Stefan Reinauer074d9132009-09-26 16:43:17 +0000193# parse parameters.. try to find out whether we're running GNU getopt
Peter Stuge09377b72011-08-21 06:24:55 +0200194getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
195if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000196 # Detected GNU getopt that supports long options.
Patrick Georgic1a75b12011-11-04 21:37:14 +0100197 args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache Vhcd:p:j:D:tGy -- "$@"`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000198 eval set "$args"
199else
200 # Detected non-GNU getopt
Patrick Georgic1a75b12011-11-04 21:37:14 +0100201 args=`getopt Vhcd:p:j:D:tGy $*`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000202 set -- $args
203fi
204
205if [ $? != 0 ]; then
206 myhelp
207 exit 1
208fi
209
210while true ; do
211 case "$1" in
212 -V|--version) shift; myversion; exit 0;;
213 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100214 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000215 -t|--savetemps) shift; SAVETEMPS=1;;
216 -d|--directory) shift; TARGETDIR="$1"; shift;;
217 -p|--platform) shift; TARGETARCH="$1"; shift;;
218 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000219 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100220 -G|--gdb) shift; SKIPGDB=0;;
221 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100222 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200223 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000224 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200225 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000226 esac
227done
228
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700229case "$TARGETARCH" in
David Hubbard5b0420a2013-05-28 16:33:15 -0600230 i386-elf) ;;
231 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100232 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100233 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700234 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200235 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700236 aarch64*) TARGETARCH=aarch64-elf;;
237 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700238esac
239
240echo "Target arch is now $TARGETARCH"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200241BUILDDIRPREFIX=build-${TARGETARCH}
242
Patrick Georgi44af57a2013-12-19 22:06:22 +0100243if [ "$clean" = "1" ]; then
244 cleanup
245fi
246
Peter Stugeceacd772011-06-09 04:54:16 +0200247GDB_PACKAGE="GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100248PYTHON_PACKAGE="PYTHON"
249EXPAT_PACKAGE="EXPAT"
Peter Stugeceacd772011-06-09 04:54:16 +0200250if [ $SKIPGDB -eq 1 ]; then
251 printf "Will skip GDB ... ${green}ok${NC}\n"
Peter Stuge0e8ee812011-08-28 11:04:23 +0200252 GDB_ARCHIVE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200253 GDB_PACKAGE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100254 if [ $SKIPPYTHON -eq 0 ]; then
255 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
256 SKIPPYTHON=1
257 fi
258fi
259if [ $SKIPPYTHON -eq 1 ]; then
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600260 PYTHON_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100261 PYTHON_PACKAGE=""
Jonathan A. Kollasch2d7ab4c2011-11-07 13:05:18 -0600262 EXPAT_ARCHIVE=""
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100263 EXPAT_PACKAGE=""
Peter Stugeceacd772011-06-09 04:54:16 +0200264fi
265
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700266# coreboot does not like the GOLD linker
267# USE_GOLD="--enable-gold"
268USE_GOLD=""
269GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000270
Stefan Reinauer074d9132009-09-26 16:43:17 +0000271printf "Downloading tar balls ... \n"
272mkdir -p tarballs
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100273for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100274 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100275 $IASL_ARCHIVE $PYTHON_ARCHIVE $EXPAT_ARCHIVE; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000276 FILE=`basename $ARCHIVE`
277 printf " * $FILE "
278 test -f tarballs/$FILE && printf "(cached)" || (
279 printf "(downloading)"
280 cd tarballs
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200281 wget --no-check-certificate -q $ARCHIVE
Stefan Reinauer074d9132009-09-26 16:43:17 +0000282 )
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100283 test -f tarballs/$FILE || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800284 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000285 test -f tarballs/$FILE || exit 1
286 printf "\n"
287done
288printf "Downloaded tar balls ... "
289printf "${green}ok${NC}\n"
290
291printf "Unpacking and patching ... \n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100292for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $PYTHON_PACKAGE \
Patrick Georgi969cd932012-12-07 13:13:53 +0100293 $EXPAT_PACKAGE $GDB_PACKAGE IASL; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000294 archive=$PACKAGE"_ARCHIVE"
Peter Stuge09377b72011-08-21 06:24:55 +0200295 archive="`eval echo '$'$archive`"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000296 dir=$PACKAGE"_DIR"
Peter Stuge09377b72011-08-21 06:24:55 +0200297 dir="`eval echo '$'${dir}`"
Zheng Baof95bb2d2013-12-13 12:30:46 +0800298 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauer074d9132009-09-26 16:43:17 +0000299 printf " * `basename $archive`\n"
300 FLAGS=zxf
Peter Stuge09377b72011-08-21 06:24:55 +0200301 suffix=`echo $archive | sed 's,.*\.,,'`
302 test "$suffix" = "gz" && FLAGS=zxf
303 test "$suffix" = "bz2" && FLAGS=jxf
Patrick Georgi53c388f2015-03-07 09:55:18 +0100304 test "$suffix" = "xz" && FLAGS="--xz -xf"
Peter Stuge09377b72011-08-21 06:24:55 +0200305 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000306 $TAR $FLAGS tarballs/`basename $archive`
Peter Stuge09377b72011-08-21 06:24:55 +0200307 for patch in patches/${dir}_*.patch; do
Stefan Reinauer074d9132009-09-26 16:43:17 +0000308 test -r $patch || continue
309 printf " o `basename $patch`\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100310 $PATCH -s -N -p0 < `echo $patch` || \
Zheng Bao5b209c02012-09-20 16:09:51 +0800311 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000312 done
Zheng Bao691b313c2013-12-09 14:09:07 +0800313 touch ${dir}/.unpack_success
Stefan Reinauer074d9132009-09-26 16:43:17 +0000314 )
315done
316printf "Unpacked and patched ... "
317printf "${green}ok${NC}\n"
318
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700319CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700320if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000321 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
322
323 # generally the OS X compiler can create x64 binaries.
324 # Per default it generated i386 binaries in 10.5 and x64
325 # binaries in 10.6 (even if the kernel is 32bit)
326 # For some weird reason, 10.5 autodetects an ABI=64 though
327 # so we're setting the ABI explicitly here.
Zheng Bao04ceed62012-10-23 19:41:25 +0800328 if [ `sysctl -n hw.optional.x86_64 2>/dev/null` -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000329 OPTIONS="ABI=64"
330 else
331 OPTIONS="ABI=32"
332 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700333
Stefan Reinauer4266b922012-12-05 16:18:32 -0800334 # In Xcode 4.5.2 the default compiler is clang.
335 # However, this compiler fails to compile gcc 4.7.x. As a
336 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700337 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800338 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700339 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000340fi
341
Patrick Georgic1a75b12011-11-04 21:37:14 +0100342if [ "$USECCACHE" = 1 ]; then
343 CC="ccache $CC"
344fi
345
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200346mkdir -p ${BUILDDIRPREFIX}-gmp ${BUILDDIRPREFIX}-mpfr ${BUILDDIRPREFIX}-mpc ${BUILDDIRPREFIX}-libelf ${BUILDDIRPREFIX}-binutils \
347 ${BUILDDIRPREFIX}-gcc ${BUILDDIRPREFIX}-python ${BUILDDIRPREFIX}-expat
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100348
349mkdir -p $DESTDIR$TARGETDIR/bin
350export PATH=$DESTDIR$TARGETDIR/bin:$PATH
351
Peter Stugeceacd772011-06-09 04:54:16 +0200352if [ $SKIPGDB -eq 0 ]; then
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200353 mkdir -p ${BUILDDIRPREFIX}-gdb
Peter Stugeceacd772011-06-09 04:54:16 +0200354fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200355if [ -f ${BUILDDIRPREFIX}-gmp/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000356 printf "Skipping GMP as it is already built\n"
357else
358printf "Building GMP ${GMP_VERSION} ... "
359(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200360 cd ${BUILDDIRPREFIX}-gmp
Stefan Reinauer074d9132009-09-26 16:43:17 +0000361 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100362 CC="$CC" ../${GMP_DIR}/configure --disable-shared --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000363 || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000364 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000365 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100366
367 normalize_dirs
368
Stefan Reinauer074d9132009-09-26 16:43:17 +0000369 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200370) > ${BUILDDIRPREFIX}-gmp/crossgcc-build.log 2>&1
371test -r ${BUILDDIRPREFIX}-gmp/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100372 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200373test -r ${BUILDDIRPREFIX}-gmp/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000374fi
375
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700376# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
377# as GCC 4.6.x fails if it's there.
378HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
379 sed s,-pedantic,,`
Stefan Reinauer074d9132009-09-26 16:43:17 +0000380
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200381if [ -f ${BUILDDIRPREFIX}-mpfr/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000382 printf "Skipping MPFR as it is already built\n"
383else
384printf "Building MPFR ${MPFR_VERSION} ... "
385(
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700386 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200387 cd ${BUILDDIRPREFIX}-mpfr
Stefan Reinauer074d9132009-09-26 16:43:17 +0000388 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100389 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000390 --infodir=$TARGETDIR/info \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100391 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
392 touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000393 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000394 $MAKE install DESTDIR=$DESTDIR || touch .failed
395
Patrick Georgi198d23c2012-12-08 08:02:44 +0100396 normalize_dirs
397
Stefan Reinauer074d9132009-09-26 16:43:17 +0000398 # work around build problem of libgmp.la
399 if [ "$DESTDIR" != "" ]; then
400 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
401 fi
402
403 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200404) > ${BUILDDIRPREFIX}-mpfr/crossgcc-build.log 2>&1
405test -r ${BUILDDIRPREFIX}-mpfr/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100406 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200407test -r ${BUILDDIRPREFIX}-mpfr/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000408fi
409
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200410if [ -f ${BUILDDIRPREFIX}-mpc/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000411 printf "Skipping MPC as it is already built\n"
412else
413printf "Building MPC ${MPC_VERSION} ... "
414(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200415 cd ${BUILDDIRPREFIX}-mpc
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000416 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100417 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000418 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100419 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
420 touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000421 $MAKE $JOBS || touch .failed
422 $MAKE install DESTDIR=$DESTDIR || touch .failed
423
Patrick Georgi198d23c2012-12-08 08:02:44 +0100424 normalize_dirs
425
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000426 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200427) > ${BUILDDIRPREFIX}-mpc/crossgcc-build.log 2>&1
428test -r ${BUILDDIRPREFIX}-mpc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100429 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200430test -r ${BUILDDIRPREFIX}-mpc/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000431fi
432
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200433if [ -f ${BUILDDIRPREFIX}-libelf/.success ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000434 printf "Skipping libelf as it is already built\n"
435else
436printf "Building libelf ${LIBELF_VERSION} ... "
437(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200438 cd ${BUILDDIRPREFIX}-libelf
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000439 rm -f .failed
440 echo "$HOSTCFLAGS"
Patrick Georgi643c9e82011-11-04 21:30:49 +0100441 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100442 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000443 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
444 $MAKE $JOBS || touch .failed
Scott Duplichan4270a972014-12-12 20:21:40 -0600445 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000446
Patrick Georgi198d23c2012-12-08 08:02:44 +0100447 normalize_dirs
448
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000449 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200450) > ${BUILDDIRPREFIX}-libelf/crossgcc-build.log 2>&1
451test -r ${BUILDDIRPREFIX}-libelf/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100452 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200453test -r ${BUILDDIRPREFIX}-libelf/.failed && exit 1
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000454fi
455
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200456if [ -f ${BUILDDIRPREFIX}-binutils/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000457 printf "Skipping binutils as it is already built\n"
458else
459printf "Building binutils ${BINUTILS_VERSION} ... "
460(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700461 # What a pain: binutils don't come with configure
462 # script anymore. Create it:
463 cd binutils-${BINUTILS_VERSION}/
464 autoconf
465 cd ..
466 # Now build binutils
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200467 cd ${BUILDDIRPREFIX}-binutils
Stefan Reinauer074d9132009-09-26 16:43:17 +0000468 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100469 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100470 --target=${TARGETARCH} --disable-werror --disable-nls \
471 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
Patrick Georgi73166c72010-04-14 20:42:42 +0000472 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000473 $MAKE install DESTDIR=$DESTDIR || touch .failed
474 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200475) > ${BUILDDIRPREFIX}-binutils/crossgcc-build.log 2>&1
476test -r ${BUILDDIRPREFIX}-binutils/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100477 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200478test -r ${BUILDDIRPREFIX}-binutils/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000479fi
480
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200481if [ -f ${BUILDDIRPREFIX}-gcc/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000482 printf "Skipping GCC as it is already built\n"
483else
484printf "Building GCC ${GCC_VERSION} ... "
485(
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700486 # Even worse than binutils: GCC does not come with configure
487 # script anymore, but also enforces an obsolete autoconf version
488 # to create it. This is a poster child of how autotools help make
489 # software portable.
490 cd gcc-${GCC_VERSION}
491 sed '/dnl Ensure exactly this Autoconf version is used/d' \
492 config/override.m4 > config/override.m4.new
493 autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
494 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
495 config/override.m4.new > config/override.m4
496 autoconf
497 cd ..
498 # Now, finally, we can build gcc:
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200499 cd ${BUILDDIRPREFIX}-gcc
Stefan Reinauer074d9132009-09-26 16:43:17 +0000500 rm -f .failed
501 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
502 # both target and host object files. This is pretty misdesigned.
503 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
504 # but it does not seem to work properly. At least the host library
505 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700506 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
507 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000508 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
Stefan Reinauer6ade1612010-01-16 16:44:20 +0000509 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000510 --disable-libssp --disable-bootstrap --disable-nls \
Patrick Georgi969cd932012-12-07 13:13:53 +0100511 --disable-libquadmath --without-headers \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000512 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000513 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000514 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
515 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
Stefan Reinauer074d9132009-09-26 16:43:17 +0000516 || touch .failed
Patrick Georgi969cd932012-12-07 13:13:53 +0100517 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
518 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
519
520 if [ "`echo $TARGETARCH | grep -c -- -mingw32`" -eq 0 ]; then
521 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
522 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
523 fi
524
Stefan Reinauer074d9132009-09-26 16:43:17 +0000525 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200526) > ${BUILDDIRPREFIX}-gcc/crossgcc-build.log 2>&1
527test -r ${BUILDDIRPREFIX}-gcc/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100528 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200529test -r ${BUILDDIRPREFIX}-gcc/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000530fi
531
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200532if [ -f ${BUILDDIRPREFIX}-expat/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100533 printf "Skipping Expat as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100534elif [ $SKIPPYTHON -eq 1 ]; then
535 printf "Skipping Expat (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100536else
537printf "Building Expat ${EXPAT_VERSION} ... "
538(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200539 cd ${BUILDDIRPREFIX}-expat
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100540 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100541 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100542 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
543 $MAKE || touch .failed
544 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100545
546 normalize_dirs
547
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100548 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200549) > ${BUILDDIRPREFIX}-expat/crossgcc-build.log 2>&1
550test -r ${BUILDDIRPREFIX}-expat/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100551 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200552test -r ${BUILDDIRPREFIX}-expat/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100553fi
554
555
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200556if [ -f ${BUILDDIRPREFIX}-python/.success ]; then
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100557 printf "Skipping Python as it is already built\n"
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100558elif [ $SKIPPYTHON -eq 1 ]; then
559 printf "Skipping Python (Python scripting not enabled)\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100560else
561printf "Building Python ${PYTHON_VERSION} ... "
562(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200563 cd ${BUILDDIRPREFIX}-python
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100564 rm -f .failed
Patrick Georgi643c9e82011-11-04 21:30:49 +0100565 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100566 --target=${TARGETARCH} || touch .failed
567 $MAKE $JOBS || touch .failed
568 $MAKE install DESTDIR=$DESTDIR || touch .failed
Patrick Georgi198d23c2012-12-08 08:02:44 +0100569
570 normalize_dirs
571
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100572 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200573) > ${BUILDDIRPREFIX}-python/crossgcc-build.log 2>&1
574test -r ${BUILDDIRPREFIX}-python/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100575 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200576test -r ${BUILDDIRPREFIX}-python/.failed && exit 1
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100577fi
578
579
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200580if [ -f ${BUILDDIRPREFIX}-gdb/.success ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000581 printf "Skipping GDB as it is already built\n"
Peter Stugeceacd772011-06-09 04:54:16 +0200582elif [ $SKIPGDB -eq 1 ]; then
Stefan Reinauer1200ec52011-11-01 22:39:41 +0100583 printf "Skipping GDB (GDB support not enabled)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000584else
585printf "Building GDB ${GDB_VERSION} ... "
586(
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200587 cd ${BUILDDIRPREFIX}-gdb
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100588 export PYTHONHOME=$DESTDIR$TARGETDIR
Stefan Reinauer074d9132009-09-26 16:43:17 +0000589 rm -f .failed
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100590 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
591 -lpthread -ldl -lutil" \
Patrick Georgi643c9e82011-11-04 21:30:49 +0100592 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100593 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
594 --target=${TARGETARCH} --disable-werror --disable-nls
Patrick Georgi73166c72010-04-14 20:42:42 +0000595 $MAKE $JOBS || touch .failed
Stefan Reinauer074d9132009-09-26 16:43:17 +0000596 $MAKE install DESTDIR=$DESTDIR || touch .failed
597 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200598) > ${BUILDDIRPREFIX}-gdb/crossgcc-build.log 2>&1
599test -r ${BUILDDIRPREFIX}-gdb/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100600 printf "${green}ok${NC}\n"
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200601test -r ${BUILDDIRPREFIX}-gdb/.failed && exit 1
Stefan Reinauer074d9132009-09-26 16:43:17 +0000602fi
603
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200604if [ -f $IASL_DIR/source/compiler/.success ]; then
Marc Jones2aac3f62011-08-08 16:07:50 -0600605 printf "Skipping IASL as it is already built\n"
606else
607printf "Building IASL ${IASL_VERSION} ... "
608(
Idwer Vollering6b11c8b2012-11-15 21:14:36 +0100609 cd $IASL_DIR/generate/unix
Stefan Reinauer4266b922012-12-05 16:18:32 -0800610 rm -f .failed
Marc Jones2aac3f62011-08-08 16:07:50 -0600611 CFLAGS="$HOSTCFLAGS"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700612 HOST="_LINUX"
613 test $UNAME = "Darwin" && HOST="_APPLE"
614 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
615 test $UNAME = "Cygwin" && HOST="_CYGWIN"
616 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800617 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
Zheng Bao3c4bd912013-08-27 10:23:13 +0800618 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch .failed
Stefan Reinauer4266b922012-12-05 16:18:32 -0800619 if [ ! -f .failed ]; then touch .success; fi
Patrick Georgi6e61ad32012-05-12 23:19:30 +0200620) > $IASL_DIR/source/compiler/crossgcc-build.log 2>&1
Stefan Reinauer4266b922012-12-05 16:18:32 -0800621test -r $IASL_DIR/generate/unix/.failed && printf "${RED}failed${NC}\n" || \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100622 printf "${green}ok${NC}\n"
Stefan Reinauer4266b922012-12-05 16:18:32 -0800623test -r $IASL_DIR/generate/unix/.failed && exit 1
Marc Jones2aac3f62011-08-08 16:07:50 -0600624fi
625
Zheng Bao30b895f2013-02-06 18:04:40 +0800626rm -f $DESTDIR$TARGETDIR/$0.commit.*
627cp $0 $DESTDIR$TARGETDIR/"$0.commit.`git describe`"
628
Stefan Reinauer074d9132009-09-26 16:43:17 +0000629if [ $SAVETEMPS -eq 0 ]; then
630 printf "Cleaning up... "
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200631 rm -rf ${GMP_DIR} ${BUILDDIRPREFIX}-gmp
632 rm -rf ${MPFR_DIR} ${BUILDDIRPREFIX}-mpfr
633 rm -rf ${MPC_DIR} ${BUILDDIRPREFIX}-mpc
634 rm -rf ${LIBELF_DIR} ${BUILDDIRPREFIX}-libelf
635 rm -rf ${BINUTILS_DIR} ${BUILDDIRPREFIX}-binutils
636 rm -rf ${GCC_DIR} ${BUILDDIRPREFIX}-gcc
637 rm -rf ${GDB_DIR} ${BUILDDIRPREFIX}-gdb
638 rm -rf ${EXPAT_DIR} ${BUILDDIRPREFIX}-expat
639 rm -rf ${PYTHON_DIR} ${BUILDDIRPREFIX}-python
Marc Jones2aac3f62011-08-08 16:07:50 -0600640 rm -rf ${IASL_DIR}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000641 printf "${green}ok${NC}\n"
642else
643 printf "Leaving temporary files around... ${green}ok${NC}\n"
644fi
645
646printf "\n${green}You can now run your $TARGETARCH cross toolchain from $TARGETDIR.${NC}\n"
647
648